## drogon 1.8.4+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(drogon)

message(STATUS "compiler: " ${CMAKE_CXX_COMPILER_ID})

# If your cross compile is failing, you should set
# CMAKE_SYSTEM_NAME in your toolchain file
if (NOT CMAKE_CROSSCOMPILING)
    set(BUILD_PROGRAMS ON)
else ()
    set(BUILD_PROGRAMS OFF)
endif ()

option(BUILD_CTL "Build drogon_ctl" ${BUILD_PROGRAMS})
option(BUILD_EXAMPLES "Build examples" ${BUILD_PROGRAMS})
option(BUILD_ORM "Build orm" ON)
option(COZ_PROFILING "Use coz for profiling" OFF)
option(BUILD_SHARED_LIBS "Build drogon as a shared lib" OFF)
option(BUILD_DOC "Build Doxygen documentation" OFF)
option(BUILD_BROTLI "Build Brotli" ON)
option(BUILD_YAML_CONFIG "Build yaml config" ON)
option(USE_SUBMODULE "Use trantor as a submodule" ON)

include(CMakeDependentOption)
CMAKE_DEPENDENT_OPTION(BUILD_POSTGRESQL "Build with postgresql support" ON "BUILD_ORM" OFF)
CMAKE_DEPENDENT_OPTION(LIBPQ_BATCH_MODE "Use batch mode for libpq" ON "BUILD_POSTGRESQL" OFF)
CMAKE_DEPENDENT_OPTION(BUILD_MYSQL "Build with mysql support" ON "BUILD_ORM" OFF)
CMAKE_DEPENDENT_OPTION(BUILD_SQLITE "Build with sqlite3 support" ON "BUILD_ORM" OFF)
CMAKE_DEPENDENT_OPTION(BUILD_REDIS "Build with redis support" ON "BUILD_ORM" OFF)

set(DROGON_MAJOR_VERSION 1)
set(DROGON_MINOR_VERSION 8)
set(DROGON_PATCH_VERSION 4)
set(DROGON_VERSION
    ${DROGON_MAJOR_VERSION}.${DROGON_MINOR_VERSION}.${DROGON_PATCH_VERSION})
set(DROGON_VERSION_STRING "${DROGON_VERSION}")

include(GNUInstallDirs)
# Offer the user the choice of overriding the installation directories
set(INSTALL_LIB_DIR ${CMAKE_INSTALL_LIBDIR} CACHE PATH "Installation directory for libraries")
set(INSTALL_BIN_DIR ${CMAKE_INSTALL_BINDIR} CACHE PATH "Installation directory for executables")
set(INSTALL_INCLUDE_DIR ${CMAKE_INSTALL_INCLUDEDIR} CACHE PATH "Installation directory for header files")
set(DEF_INSTALL_DROGON_CMAKE_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/Drogon)
set(INSTALL_DROGON_CMAKE_DIR ${DEF_INSTALL_DROGON_CMAKE_DIR}
    CACHE PATH "Installation directory for cmake files")

if (CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    # Force MSVC to use UTF-8 because that's what we use. Otherwise it uses
    # the default of whatever Windows sets and causes encoding issues.
    message(STATUS "You are using MSVC. Forceing to use UTF-8")
    add_compile_options("$<$<C_COMPILER_ID:MSVC>:/utf-8>")
    add_compile_options("$<$<CXX_COMPILER_ID:MSVC>:/utf-8>")
endif ()

add_library(${PROJECT_NAME})
if (BUILD_SHARED_LIBS)
    find_package(Threads)
    # set(BUILD_EXAMPLES FALSE)
    list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES
        "${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}" isSystemDir)
    if ("${isSystemDir}" STREQUAL "-1")
        set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}")
    endif ("${isSystemDir}" STREQUAL "-1")
    set_target_properties(${PROJECT_NAME} PROPERTIES
        VERSION ${DROGON_VERSION}
        SOVERSION ${DROGON_MAJOR_VERSION})
    target_link_libraries(${PROJECT_NAME} PUBLIC Threads::Threads)
    if (WIN32)
        target_link_libraries(${PROJECT_NAME} PUBLIC Rpcrt4 ws2_32 crypt32 Advapi32)
        if (CMAKE_CXX_COMPILER_ID MATCHES MSVC)
            # Ignore MSVC C4251 and C4275 warning of exporting std objects with no dll export
            # We export class to facilitate maintenance, thus if you compile
            # drogon on windows as a shared library, you will need to use
            # exact same compiler for drogon and your app.
            target_compile_options(${PROJECT_NAME} PUBLIC /wd4251 /wd4275)
        endif ()
    endif ()
endif (BUILD_SHARED_LIBS)

if (NOT ${CMAKE_PLATFORM_NAME} STREQUAL "Windows" AND CMAKE_CXX_COMPILER_ID MATCHES GNU)
    target_compile_options(${PROJECT_NAME} PRIVATE -Wall -Wextra -Werror)
endif ()

include(GenerateExportHeader)
generate_export_header(${PROJECT_NAME} EXPORT_FILE_NAME ${CMAKE_CURRENT_BINARY_DIR}/exports/drogon/exports.h)

include(cmake/DrogonUtilities.cmake)
include(cmake/ParseAndAddDrogonTests.cmake)
include(CheckIncludeFileCXX)

check_include_file_cxx(any HAS_ANY)
check_include_file_cxx(string_view HAS_STRING_VIEW)
check_include_file_cxx(coroutine HAS_COROUTINE)
if (NOT "${CMAKE_CXX_STANDARD}" STREQUAL "")
    set(DROGON_CXX_STANDARD ${CMAKE_CXX_STANDARD})
elseif (HAS_ANY AND HAS_STRING_VIEW AND HAS_COROUTINE)
    set(DROGON_CXX_STANDARD 20)
elseif (HAS_ANY AND HAS_STRING_VIEW)
    set(DROGON_CXX_STANDARD 17)
else ()
    set(DROGON_CXX_STANDARD 14)
endif ()
if(USE_SUBMODULE)
    target_include_directories(
            ${PROJECT_NAME}
            PUBLIC
            $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/trantor>)
endif()
target_include_directories(
    ${PROJECT_NAME}
    PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/lib/inc>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/orm_lib/inc>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/nosql_lib/redis/inc>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/exports>
    $<INSTALL_INTERFACE:${INSTALL_INCLUDE_DIR}>)

if (WIN32)
    target_include_directories(
        ${PROJECT_NAME}
        PRIVATE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/third_party/mman-win32>)
endif (WIN32)

if(USE_SUBMODULE)
add_subdirectory(trantor)
target_link_libraries(${PROJECT_NAME} PUBLIC trantor)
else()
find_package(Trantor CONFIG REQUIRED)
target_link_libraries(${PROJECT_NAME} PUBLIC Trantor::Trantor)
endif()

if(${CMAKE_SYSTEM_NAME} STREQUAL "Haiku")
    target_link_libraries(${PROJECT_NAME} PRIVATE network)
elseif (NOT WIN32 AND NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
    target_link_libraries(${PROJECT_NAME} PRIVATE dl)
elseif (WIN32)
    target_link_libraries(${PROJECT_NAME} PRIVATE shlwapi)
endif ()

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_modules/)

find_package(Filesystem COMPONENTS Final)
if(CXX_FILESYSTEM_HAVE_FS)
    message(STATUS "Found std::filesystem")
endif()

# Check for C++ filesystem support
set(NEED_BOOST_FS 0)
if (DROGON_CXX_STANDARD EQUAL 14)
    # With C++14, use Boost to support any and string_view
    message(STATUS "use c++14")
    find_package(Boost 1.61.0 REQUIRED)
    message(STATUS "Using Boost filesystem, string_view and any")
    message(STATUS "Boost include dir: " ${Boost_INCLUDE_DIR})
    target_link_libraries(${PROJECT_NAME} PUBLIC Boost::boost)
    list(APPEND INCLUDE_DIRS_FOR_DYNAMIC_VIEW ${Boost_INCLUDE_DIR})
    set(NEED_BOOST_FS 1)
elseif (DROGON_CXX_STANDARD EQUAL 17)
    # With C++17, use Boost if std::filesystem::path is missing
    message(STATUS "use c++17")

    # Check for partial implementation of c++17 (Windows/OSX only?)
    if (CXX_FILESYSTEM_HAVE_FS)
        set(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)
        try_compile(check_filesystem_path ${CMAKE_BINARY_DIR}/cmaketest
            ${PROJECT_SOURCE_DIR}/cmake/tests/check_has_std_filesystem_path.cc
            CXX_STANDARD 17)
        set(CMAKE_TRY_COMPILE_TARGET_TYPE)
        if (NOT check_filesystem_path)
          message(STATUS "The std::filesystem seems to be a partial implementation"
            " Falling back to boost::filesystem")
            set(NEED_BOOST_FS 1)
        endif()
    else()
        set(NEED_BOOST_FS 1)
    endif()
else ()
    message(STATUS "use c++20")
endif ()

# Workaround: 2021-08-09 Android NDK does not provide proper std::filesystem
# support. Force boost::filesystem instead.
if (${CMAKE_SYSTEM_NAME} STREQUAL "Android")
    message(STATUS "WORKAROUND: Forcing boost::filesystem on Android")
    set(NEED_BOOST_FS 1)
endif ()

if(NEED_BOOST_FS)
    find_package(Boost 1.49.0 COMPONENTS filesystem system REQUIRED)
    message(STATUS "Using Boost filesytem::path")
    message(STATUS "Boost include dir: " ${Boost_INCLUDE_DIR})
    include_directories(${BOOST_INCLUDE_DIRS})
    message(STATUS "Boost libraries: " ${Boost_LIBRARIES})
    target_link_libraries(${PROJECT_NAME} PUBLIC Boost::filesystem Boost::system)
    list(APPEND INCLUDE_DIRS_FOR_DYNAMIC_VIEW ${Boost_INCLUDE_DIR})
    option(HAS_STD_FILESYSTEM_PATH "use boost::filesystem" OFF)
else()
    option(HAS_STD_FILESYSTEM_PATH "use std::filesystem" ON)
    # HACK: Needed to be compiled on Yocto Linux
    if(TARGET std::filesystem)
      get_property(CAN_LINK_FS TARGET std::filesystem PROPERTY INTERFACE_LINK_LIBRARIES SET)
      if ( CAN_LINK_FS )
        target_link_libraries(${PROJECT_NAME} PUBLIC std::filesystem)
      endif()
    endif()
endif()

# jsoncpp
find_package(Jsoncpp REQUIRED)
target_link_libraries(${PROJECT_NAME} PUBLIC Jsoncpp_lib)
list(APPEND INCLUDE_DIRS_FOR_DYNAMIC_VIEW ${JSONCPP_INCLUDE_DIRS})

# yamlcpp
if(BUILD_YAML_CONFIG)
    find_package(yaml-cpp QUIET)
    if(yaml-cpp_FOUND)
    message(STATUS "yaml-cpp found")
    target_link_libraries(${PROJECT_NAME} PUBLIC ${YAML_CPP_LIBRARIES})
    target_compile_definitions(${PROJECT_NAME} PUBLIC HAS_YAML_CPP)
    else()
    message(STATUS "yaml-cpp not used")
    endif(yaml-cpp_FOUND)
else()
    message(STATUS "yaml-cpp not used")
endif(BUILD_YAML_CONFIG)

if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD"
    AND NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD"
    AND NOT WIN32)
    find_package(UUID REQUIRED)
    target_link_libraries(${PROJECT_NAME} PRIVATE UUID_lib)

    try_compile(normal_uuid ${CMAKE_BINARY_DIR}/cmaketest
        ${PROJECT_SOURCE_DIR}/cmake/tests/normal_uuid_lib_test.cc
        LINK_LIBRARIES UUID_lib)
    try_compile(ossp_uuid ${CMAKE_BINARY_DIR}/cmaketest
        ${PROJECT_SOURCE_DIR}/cmake/tests/ossp_uuid_lib_test.cc
        LINK_LIBRARIES UUID_lib)
    if (normal_uuid)
        add_definitions(-DUSE_OSSP_UUID=0)
    elseif (ossp_uuid)
        add_definitions(-DUSE_OSSP_UUID=1)
    else ()
        message(FATAL_ERROR "uuid lib error")
    endif ()
endif (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD"
    AND NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD"
    AND NOT WIN32)

if (BUILD_BROTLI)
    find_package(Brotli)
    if (Brotli_FOUND)
        message(STATUS "Brotli found")
        add_definitions(-DUSE_BROTLI)
        target_link_libraries(${PROJECT_NAME} PRIVATE Brotli_lib)
    endif (Brotli_FOUND)
endif (BUILD_BROTLI)

set(DROGON_SOURCES
    lib/src/AOPAdvice.cc
    lib/src/CacheFile.cc
    lib/src/ConfigLoader.cc
    lib/src/Cookie.cc
    lib/src/DrClassMap.cc
    lib/src/DrTemplateBase.cc
    lib/src/FiltersFunction.cc
    lib/src/HttpAppFrameworkImpl.cc
    lib/src/HttpBinder.cc
    lib/src/HttpClientImpl.cc
    lib/src/HttpControllersRouter.cc
    lib/src/HttpFileImpl.cc
    lib/src/HttpFileUploadRequest.cc
    lib/src/HttpRequestImpl.cc
    lib/src/HttpRequestParser.cc
    lib/src/HttpResponseImpl.cc
    lib/src/HttpResponseParser.cc
    lib/src/HttpServer.cc
    lib/src/HttpSimpleControllersRouter.cc
    lib/src/HttpUtils.cc
    lib/src/HttpViewData.cc
    lib/src/IntranetIpFilter.cc
    lib/src/ListenerManager.cc
    lib/src/LocalHostFilter.cc
    lib/src/MultiPart.cc
    lib/src/NotFound.cc
    lib/src/PluginsManager.cc
    lib/src/RangeParser.cc
    lib/src/SecureSSLRedirector.cc
    lib/src/AccessLogger.cc
    lib/src/RealIpResolver.cc
    lib/src/SessionManager.cc
    lib/src/StaticFileRouter.cc
    lib/src/TaskTimeoutFlag.cc
    lib/src/Utilities.cc
    lib/src/WebSocketClientImpl.cc
    lib/src/WebSocketConnectionImpl.cc
    lib/src/WebsocketControllersRouter.cc
    lib/src/RateLimiter.cc
    lib/src/FixedWindowRateLimiter.cc
    lib/src/SlidingWindowRateLimiter.cc
    lib/src/TokenBucketRateLimiter.cc
    lib/src/Hodor.cc
    lib/src/drogon_test.cc
    lib/src/ConfigAdapterManager.cc
    lib/src/JsonConfigAdapter.cc
    lib/src/YamlConfigAdapter.cc)
set(private_headers
    lib/src/AOPAdvice.h
    lib/src/CacheFile.h
    lib/src/ConfigLoader.h
    lib/src/filesystem.h
    lib/src/FiltersFunction.h
    lib/src/HttpAppFrameworkImpl.h
    lib/src/HttpClientImpl.h
    lib/src/HttpControllersRouter.h
    lib/src/HttpFileImpl.h
    lib/src/HttpFileUploadRequest.h
    lib/src/HttpMessageBody.h
    lib/src/HttpRequestImpl.h
    lib/src/HttpRequestParser.h
    lib/src/HttpResponseImpl.h

=== drogon_ctl/CMakeLists.txt ===
set(ctl_sources
    cmd.cc
    create.cc
    create_controller.cc
    create_filter.cc
    create_model.cc
    create_plugin.cc
    create_project.cc
    create_view.cc
    help.cc
    main.cc
    press.cc
    version.cc)
add_executable(_drogon_ctl
               main.cc
               cmd.cc
               create.cc
               create_view.cc)
target_link_libraries(_drogon_ctl ${PROJECT_NAME})
if (WIN32 AND BUILD_SHARED_LIBS)
  set(DROGON_FILE $<TARGET_FILE:drogon>)
  set(TRANTOR_FILE $<TARGET_FILE:trantor>)
  add_custom_command(TARGET _drogon_ctl POST_BUILD
          COMMAND ${CMAKE_COMMAND}
          -DCTL_FILE=${DROGON_FILE}
          -DINSTALL_BIN_DIR=$<TARGET_FILE_DIR:_drogon_ctl>
          -P
          ${CMAKE_CURRENT_SOURCE_DIR}/CopyDlls.cmake)
  add_custom_command(TARGET _drogon_ctl POST_BUILD
          COMMAND ${CMAKE_COMMAND}
          -DCTL_FILE=${TRANTOR_FILE}
          -DINSTALL_BIN_DIR=$<TARGET_FILE_DIR:_drogon_ctl>
          -P
          ${CMAKE_CURRENT_SOURCE_DIR}/CopyDlls.cmake)
endif()
file(GLOB SCP_LIST ${CMAKE_CURRENT_SOURCE_DIR}/templates/*.csp)
foreach(cspFile ${SCP_LIST})
  message(STATUS "cspFile:" ${cspFile})
  get_filename_component(classname ${cspFile} NAME_WE)
  message(STATUS "view classname:" ${classname})
  add_custom_command(OUTPUT ${classname}.h ${classname}.cc
                     COMMAND $<TARGET_FILE:_drogon_ctl>
                             ARGS
                             create
                             view
                             ${cspFile}
                     DEPENDS ${cspFile}
                     VERBATIM)
  set(TEMPL_SRC ${TEMPL_SRC} ${classname}.cc)
endforeach()
add_executable(drogon_ctl ${ctl_sources} ${TEMPL_SRC})
target_link_libraries(drogon_ctl PRIVATE ${PROJECT_NAME})
target_include_directories(drogon_ctl PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
add_dependencies(drogon_ctl _drogon_ctl)
if(WIN32)
  target_link_libraries(drogon_ctl PRIVATE ws2_32 Rpcrt4 iphlpapi)
endif(WIN32)
if(APPLE)
  target_link_libraries(drogon_ctl PRIVATE resolv)
endif()
message(STATUS "bin:" ${INSTALL_BIN_DIR})
install(TARGETS drogon_ctl RUNTIME DESTINATION ${INSTALL_BIN_DIR})
if(WIN32)
  set(CTL_FILE $<TARGET_FILE:drogon_ctl>)
  add_custom_command(TARGET drogon_ctl POST_BUILD
                     COMMAND ${CMAKE_COMMAND}
                             -DCTL_FILE=${CTL_FILE}
                             -DINSTALL_BIN_DIR=${INSTALL_BIN_DIR}
                             -DRENAME_EXE=ON
                             -P
                             ${CMAKE_CURRENT_SOURCE_DIR}/CopyDlls.cmake)
else(WIN32)
  install(CODE "execute_process( \
    COMMAND ${CMAKE_COMMAND} -E create_symlink \
    ./drogon_ctl \
    ./dg_ctl \
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})")
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/dg_ctl"
          DESTINATION ${INSTALL_BIN_DIR})
endif(WIN32)
set(ctl_targets _drogon_ctl drogon_ctl)
set_property(TARGET ${ctl_targets} PROPERTY CXX_STANDARD ${DROGON_CXX_STANDARD})
set_property(TARGET ${ctl_targets} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${ctl_targets} PROPERTY CXX_EXTENSIONS OFF)

=== lib/tests/CMakeLists.txt ===
link_libraries(${PROJECT_NAME})
if(WIN32)
  link_libraries(iphlpapi)
endif(WIN32)
set(UNITTEST_SOURCES
    unittests/main.cc
    unittests/Base64Test.cc
    unittests/UrlCodecTest.cc
    unittests/GzipTest.cc
    unittests/HttpViewDataTest.cc
    unittests/CookieTest.cc
    unittests/ClassNameTest.cc
    unittests/HttpDateTest.cc
    unittests/HttpHeaderTest.cc
    unittests/MD5Test.cc
    unittests/MsgBufferTest.cc
    unittests/OStringStreamTest.cc
    unittests/PubSubServiceUnittest.cc
    unittests/Sha1Test.cc
    ../src/ssl_funcs/Sha1.cc
    unittests/FileTypeTest.cc
    unittests/DrObjectTest.cc
    unittests/HttpFullDateTest.cc
    unittests/MainLoopTest.cc
    unittests/CacheMapTest.cc
    unittests/StringOpsTest.cc
    unittests/ControllerCreationTest.cc
    unittests/MultiPartParserTest.cc)

if(DROGON_CXX_STANDARD GREATER_EQUAL 20 AND HAS_COROUTINE)
  set(UNITTEST_SOURCES ${UNITTEST_SOURCES} unittests/CoroutineTest.cc)
endif()

if(Brotli_FOUND)
  set(UNITTEST_SOURCES ${UNITTEST_SOURCES} unittests/BrotliTest.cc)
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC" AND BUILD_SHARED_LIBS)
  set(UNITTEST_SOURCES ${UNITTEST_SOURCES} ../src/HttpUtils.cc)
else()
  set(UNITTEST_SOURCES ${UNITTEST_SOURCES} ../src/HttpFileImpl.cc
                       unittests/HttpFileTest.cc)
endif()

add_executable(unittest ${UNITTEST_SOURCES})

if (BUILD_CTL)
  set(INTEGRATION_TEST_CLIENT_SOURCES
      integration_test/client/main.cc
      integration_test/client/WebSocketTest.cc
      integration_test/client/MultipleWsTest.cc
      integration_test/client/HttpPipeliningTest.cc)
  add_executable(integration_test_client ${INTEGRATION_TEST_CLIENT_SOURCES})

  set(INTEGRATION_TEST_SERVER_SOURCES
      integration_test/server/CustomCtrl.cc
      integration_test/server/CustomHeaderFilter.cc
      integration_test/server/DoNothingPlugin.cc
      integration_test/server/ForwardCtrl.cc
      integration_test/server/JsonTestController.cc
      integration_test/server/ListParaCtl.cc
      integration_test/server/PipeliningTest.cc
      integration_test/server/TestController.cc
      integration_test/server/TestPlugin.cc
      integration_test/server/TestViewCtl.cc
      integration_test/server/WebSocketTest.cc
      integration_test/server/api_Attachment.cc
      integration_test/server/api_v1_ApiTest.cc
      integration_test/server/TimeFilter.cc
      integration_test/server/DigestAuthFilter.cc
      integration_test/server/MethodTest.cc
      integration_test/server/RangeTestController.cc
      integration_test/server/BeginAdviceTest.cc
      integration_test/server/main.cc)

  if(DROGON_CXX_STANDARD GREATER_EQUAL 20 AND HAS_COROUTINE)
    set(INTEGRATION_TEST_SERVER_SOURCES
        ${INTEGRATION_TEST_SERVER_SOURCES}
        integration_test/server/CoroFilter.cpp
        integration_test/server/api_v1_CoroTest.cc)
    set(CMAKE_CXX_STANDARD 20)
    set(CMAKE_CXX_STANDARD_REQUIRED TRUE)
  endif(DROGON_CXX_STANDARD GREATER_EQUAL 20 AND HAS_COROUTINE)

  add_executable(integration_test_server ${INTEGRATION_TEST_SERVER_SOURCES})
  drogon_create_views(integration_test_server
                      ${CMAKE_CURRENT_SOURCE_DIR}/integration_test/server
                      ${CMAKE_CURRENT_BINARY_DIR})
  add_dependencies(integration_test_server drogon_ctl)
  add_custom_command(
    TARGET integration_test_server POST_BUILD
    COMMAND ${CMAKE_COMMAND}
            -E
            copy_if_different
            ${PROJECT_SOURCE_DIR}/config.example.json
            ${PROJECT_SOURCE_DIR}/drogon.jpg
            ${CMAKE_CURRENT_SOURCE_DIR}/integration_test/server/index.html
            ${CMAKE_CURRENT_SOURCE_DIR}/integration_test/server/main.cc
            ${CMAKE_CURRENT_SOURCE_DIR}/integration_test/server/test.md
            ${CMAKE_CURRENT_SOURCE_DIR}/integration_test/server/index.html.gz
            ${CMAKE_CURRENT_SOURCE_DIR}/integration_test/server/中文.txt
            ${PROJECT_SOURCE_DIR}/trantor/trantor/tests/server.pem
            $<TARGET_FILE_DIR:integration_test_server>)
  add_custom_command(
    TARGET integration_test_server POST_BUILD
    COMMAND ${CMAKE_COMMAND}
            -E
            copy_directory
            ${CMAKE_CURRENT_SOURCE_DIR}/integration_test/server/a-directory
            $<TARGET_FILE_DIR:integration_test_server>/a-directory)
endif(BUILD_CTL)

set(COOKIE_SAME_SITE 
  main_CookieSameSite.cc
  CookieSameSite.cc
)
add_executable(cookie_same_site ${COOKIE_SAME_SITE})

add_executable(real_ip_resolver RealIpResolverTest.cc)

set(tests unittest cookie_same_site real_ip_resolver)
if (BUILD_CTL)
  list(APPEND tests integration_test_server integration_test_client)
endif(BUILD_CTL)
set_property(TARGET ${tests} PROPERTY CXX_STANDARD ${DROGON_CXX_STANDARD})
set_property(TARGET ${tests} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${tests} PROPERTY CXX_EXTENSIONS OFF)

ParseAndAddDrogonTests(unittest)
ParseAndAddDrogonTests(cookie_same_site)
ParseAndAddDrogonTests(real_ip_resolver)

=== debian/changelog ===
drogon (1.8.4+ds-1build1) mantic; urgency=medium

  * Rebuild against new libyaml-cpp0.8.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 02 Sep 2023 07:18:41 +0200

drogon (1.8.4+ds-1) unstable; urgency=medium

  * Initial release (Closes: #1037495)
  * Repack to drop third_party directory

 -- Pierre-Elliott Bécue <peb@debian.org>  Mon, 26 Jun 2023 22:27:40 +0200

=== debian/control ===
Source: drogon
Maintainer: Pierre-Elliott Bécue <pierre-elliott.becue@gandi.net>
Section: web
Priority: optional
Build-Depends:
  chrpath,
  cmake,
  debhelper-compat (=13),
  dh-cmake,
  dh-cmake-compat (=1),
  doxygen,
  libbrotli-dev,
  libhiredis-dev,
  libjsoncpp-dev,
  libmariadb-dev,
  libpq-dev,
  libsqlite3-dev,
  libtrantor-dev,
  libyaml-cpp-dev,
  uuid-dev,
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/debian/drogon
Vcs-Git: https://salsa.debian.org/debian/drogon.git
Homepage: https://github.com/drogonframework/drogon
Rules-Requires-Root: no

Package: libdrogon1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++14/17-based HTTP application framework
 Drogon can be used to easily build various types of web application server
 programs using C++.
 .
 Drogon is a cross-platform framework, It supports Linux, macOS, FreeBSD,
 OpenBSD, HaikuOS, and Windows. Its main features are described in its Readme.
 .
 This package provides the Drogon Library

Package: libdrogon-dev
Architecture: any
Depends: libdrogon1 (= ${binary:Version}), libtrantor-dev, ${misc:Depends}
Description: C++14/17-based HTTP application framework
 Drogon can be used to easily build various types of web application server
 programs using C++.
 .
 Drogon is a cross-platform framework, It supports Linux, macOS, FreeBSD,
 OpenBSD, HaikuOS, and Windows. Its main features are described in its Readme.
 .
 This package provides the Drogon Library Development files

Package: drogon
Architecture: any
Depends: libdrogon1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: C++14/17-based HTTP application framework
 Drogon can be used to easily build various types of web application server
 programs using C++.
 .
 Drogon is a cross-platform framework, It supports Linux, macOS, FreeBSD,
 OpenBSD, HaikuOS, and Windows. Its main features are described in its Readme.
 .
 This package provides the Drogon binaries

## drogon 1.8.7%2Bds

=== debian/changelog ===
drogon (1.8.7+ds-1) unstable; urgency=medium

  * Drop .github and .gitmodules from upstream source
  * New upstream release 1.8.7+ds
  * Fix typo on copyright path

 -- Pierre-Elliott Bécue <pierre-elliott.becue@gandi.net>  Thu, 26 Oct 2023 21:16:37 +0200

drogon (1.8.4+ds-2) unstable; urgency=medium

  * Add lib/inc/drogon/version.h to debian/clean (Closes: #1044560)
  * Add a debian/watch file

 -- Pierre-Elliott Bécue <pierre-elliott.becue@gandi.net>  Wed, 13 Sep 2023 16:00:57 +0200

## drogon 1.8.7+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,16 +4,8 @@
 
 message(STATUS "compiler: " ${CMAKE_CXX_COMPILER_ID})
 
-# If your cross compile is failing, you should set
-# CMAKE_SYSTEM_NAME in your toolchain file
-if (NOT CMAKE_CROSSCOMPILING)
-    set(BUILD_PROGRAMS ON)
-else ()
-    set(BUILD_PROGRAMS OFF)
-endif ()
-
-option(BUILD_CTL "Build drogon_ctl" ${BUILD_PROGRAMS})
-option(BUILD_EXAMPLES "Build examples" ${BUILD_PROGRAMS})
+option(BUILD_CTL "Build drogon_ctl" ON)
+option(BUILD_EXAMPLES "Build examples" ON)
 option(BUILD_ORM "Build orm" ON)
 option(COZ_PROFILING "Use coz for profiling" OFF)
 option(BUILD_SHARED_LIBS "Build drogon as a shared lib" OFF)
@@ -31,7 +23,7 @@
 
 set(DROGON_MAJOR_VERSION 1)
 set(DROGON_MINOR_VERSION 8)
-set(DROGON_PATCH_VERSION 4)
+set(DROGON_PATCH_VERSION 7)
 set(DROGON_VERSION
     ${DROGON_MAJOR_VERSION}.${DROGON_MINOR_VERSION}.${DROGON_PATCH_VERSION})
 set(DROGON_VERSION_STRING "${DROGON_VERSION}")
@@ -215,12 +207,23 @@
 if(BUILD_YAML_CONFIG)
     find_package(yaml-cpp QUIET)
     if(yaml-cpp_FOUND)
-    message(STATUS "yaml-cpp found")
-    target_link_libraries(${PROJECT_NAME} PUBLIC ${YAML_CPP_LIBRARIES})
-    target_compile_definitions(${PROJECT_NAME} PUBLIC HAS_YAML_CPP)
+        if (NOT YAML_CPP_LIBRARIES)
+            find_library(YAML_CPP_LINK_LIBRARY "yaml-cpp")
+            if(NOT YAML_CPP_LINK_LIBRARY)
+                message(STATUS "yaml-cpp not used")
+            else()
+                message(STATUS "yaml-cpp found ")
+                target_link_libraries(${PROJECT_NAME} PUBLIC ${YAML_CPP_LINK_LIBRARY})
+                target_compile_definitions(${PROJECT_NAME} PUBLIC HAS_YAML_CPP)
+            endif()
+        else()
+            message(STATUS "yaml-cpp found ")
+            target_link_libraries(${PROJECT_NAME} PUBLIC ${YAML_CPP_LIBRARIES})
+            target_compile_definitions(${PROJECT_NAME} PUBLIC HAS_YAML_CPP)
+        endif()
     else()
-    message(STATUS "yaml-cpp not used")
-    endif(yaml-cpp_FOUND)
+        message(STATUS "yaml-cpp not used")
+    endif()
 else()
     message(STATUS "yaml-cpp not used")
 endif(BUILD_YAML_CONFIG)
@@ -233,16 +236,18 @@
 
     try_compile(normal_uuid ${CMAKE_BINARY_DIR}/cmaketest
         ${PROJECT_SOURCE_DIR}/cmake/tests/normal_uuid_lib_test.cc
-        LINK_LIBRARIES UUID_lib)
+        LINK_LIBRARIES UUID_lib
+        OUTPUT_VARIABLE NORMAL_UUID_COMPILE_OUTPUT)
     try_compile(ossp_uuid ${CMAKE_BINARY_DIR}/cmaketest
         ${PROJECT_SOURCE_DIR}/cmake/tests/ossp_uuid_lib_test.cc
-        LINK_LIBRARIES UUID_lib)
+        LINK_LIBRARIES UUID_lib
+        OUTPUT_VARIABLE OSSP_UUID_COMPILE_OUTPUT)
     if (normal_uuid)
         add_definitions(-DUSE_OSSP_UUID=0)
     elseif (ossp_uuid)
         add_definitions(-DUSE_OSSP_UUID=1)
     else ()
-        message(FATAL_ERROR "uuid lib error")
+        message(FATAL_ERROR "uuid lib error:\n${NORMAL_UUID_COMPILE_OUTPUT}\n${OSSP_UUID_COMPILE_OUTPUT}")
     endif ()
 endif (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD"
     AND NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD"
@@ -287,6 +292,7 @@
     lib/src/PluginsManager.cc
     lib/src/RangeParser.cc
     lib/src/SecureSSLRedirector.cc
+    lib/src/GlobalFilters.cc
     lib/src/AccessLogger.cc
     lib/src/RealIpResolver.cc
     lib/src/SessionManager.cc
@@ -301,22 +307,7 @@
     lib/src/SlidingWindowRateLimiter.cc
     lib/src/TokenBucketRateLimiter.cc
     lib/src/Hodor.cc
+    lib/src/SlashRemover.cc
     lib/src/drogon_test.cc
     lib/src/ConfigAdapterManager.cc
     lib/src/JsonConfigAdapter.cc
-    lib/src/YamlConfigAdapter.cc)
-set(private_headers
-    lib/src/AOPAdvice.h
-    lib/src/CacheFile.h
-    lib/src/ConfigLoader.h
-    lib/src/filesystem.h
-    lib/src/FiltersFunction.h
-    lib/src/HttpAppFrameworkImpl.h
-    lib/src/HttpClientImpl.h
-    lib/src/HttpControllersRouter.h
-    lib/src/HttpFileImpl.h
-    lib/src/HttpFileUploadRequest.h
-    lib/src/HttpMessageBody.h
-    lib/src/HttpRequestImpl.h
-    lib/src/HttpRequestParser.h
-    lib/src/HttpResponseImpl.h

=== examples/CMakeLists.txt ===
link_libraries(${PROJECT_NAME})

set(benchmark_sources benchmark/BenchmarkCtrl.cc benchmark/JsonCtrl.cc
                      benchmark/main.cc)

add_executable(client client_example/main.cc)
add_executable(websocket_client websocket_client/WebSocketClient.cc)
add_executable(websocket_server websocket_server/WebSocketServer.cc)
add_executable(benchmark ${benchmark_sources})
add_executable(helloworld helloworld/main.cc
                          helloworld/HelloController.cc
                          helloworld/HelloViewController.cc)
drogon_create_views(helloworld
                    ${CMAKE_CURRENT_SOURCE_DIR}/helloworld
                    ${CMAKE_CURRENT_BINARY_DIR})
add_executable(file_upload file_upload/file_upload.cc)
drogon_create_views(file_upload
                    ${CMAKE_CURRENT_SOURCE_DIR}/file_upload
                    ${CMAKE_CURRENT_BINARY_DIR})
add_executable(login_session login_session/main.cc)
drogon_create_views(login_session
                    ${CMAKE_CURRENT_SOURCE_DIR}/login_session
                    ${CMAKE_CURRENT_BINARY_DIR})

add_executable(jsonstore jsonstore/main.cc)

add_executable(redis_simple redis/main.cc
                            redis/controllers/Client.cc
                            redis/controllers/WsClient.cc)

add_executable(redis_chat redis_chat/main.cc
                          redis_chat/controllers/Chat.cc)

set(example_targets
    benchmark
    client
    websocket_client
    websocket_server
    helloworld
    file_upload
    login_session
    jsonstore
    redis_simple
    redis_chat)

# Add warnings for our example targets--some warnings (such as -Wunused-parameter) only appear
# when the templated functions are instantiated at their point of use.
if (CMAKE_CXX_COMPILER_ID MATCHES GNU)
    foreach(target ${example_targets})
        target_compile_options(${target} PRIVATE -Wall -Wextra -Werror)
    endforeach()
endif()

set_property(TARGET ${example_targets}
             PROPERTY CXX_STANDARD ${DROGON_CXX_STANDARD})
set_property(TARGET ${example_targets} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${example_targets} PROPERTY CXX_EXTENSIONS OFF)

=== examples/redis/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(redis CXX)

include(CheckIncludeFileCXX)

check_include_file_cxx(any HAS_ANY)
check_include_file_cxx(string_view HAS_STRING_VIEW)
check_include_file_cxx(coroutine HAS_COROUTINE)
if (HAS_ANY AND HAS_STRING_VIEW AND HAS_COROUTINE)
    set(CMAKE_CXX_STANDARD 20)
elseif (HAS_ANY AND HAS_STRING_VIEW)
    set(CMAKE_CXX_STANDARD 17)
else ()
    set(CMAKE_CXX_STANDARD 14)
endif ()

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

add_executable(${PROJECT_NAME} main.cc)

# ##############################################################################
# If you include the drogon source code locally in your project, use this method
# to add drogon 
# add_subdirectory(drogon) 
# target_link_libraries(${PROJECT_NAME} PRIVATE drogon)
#
# and comment out the following lines
find_package(Drogon CONFIG REQUIRED)
target_link_libraries(${PROJECT_NAME} PRIVATE Drogon::Drogon)

# ##############################################################################

if (CMAKE_CXX_STANDARD LESS 17)
    # With C++14, use boost to support any and string_view
    message(STATUS "use c++14")
    find_package(Boost 1.61.0 REQUIRED)
    target_include_directories(${PROJECT_NAME} PRIVATE ${Boost_INCLUDE_DIRS})
elseif (CMAKE_CXX_STANDARD LESS 20)
    message(STATUS "use c++17")
else ()
    message(STATUS "use c++20")
endif ()

aux_source_directory(controllers CTL_SRC)
aux_source_directory(filters FILTER_SRC)
aux_source_directory(plugins PLUGIN_SRC)
aux_source_directory(models MODEL_SRC)

drogon_create_views(${PROJECT_NAME} ${CMAKE_CURRENT_SOURCE_DIR}/views
                    ${CMAKE_CURRENT_BINARY_DIR})
# use the following line to create views with namespaces.
# drogon_create_views(${PROJECT_NAME} ${CMAKE_CURRENT_SOURCE_DIR}/views
#                     ${CMAKE_CURRENT_BINARY_DIR} TRUE)

target_include_directories(${PROJECT_NAME}
                           PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}
                                   ${CMAKE_CURRENT_SOURCE_DIR}/models)
target_sources(${PROJECT_NAME}
               PRIVATE
               ${SRC_DIR}
               ${CTL_SRC}
               ${FILTER_SRC}
               ${PLUGIN_SRC}
               ${MODEL_SRC})
# ##############################################################################
# uncomment the following line for dynamically loading views 
# set_property(TARGET ${PROJECT_NAME} PROPERTY ENABLE_EXPORTS ON)

=== examples/redis_chat/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(redis_chat CXX)

include(CheckIncludeFileCXX)

check_include_file_cxx(any HAS_ANY)
check_include_file_cxx(string_view HAS_STRING_VIEW)
check_include_file_cxx(coroutine HAS_COROUTINE)
if (HAS_ANY AND HAS_STRING_VIEW AND HAS_COROUTINE)
    set(CMAKE_CXX_STANDARD 20)
elseif (HAS_ANY AND HAS_STRING_VIEW)
    set(CMAKE_CXX_STANDARD 17)
else ()
    set(CMAKE_CXX_STANDARD 14)
endif ()

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

add_executable(${PROJECT_NAME} main.cc)

# ##############################################################################
# If you include the drogon source code locally in your project, use this method
# to add drogon
# add_subdirectory(drogon)
# target_link_libraries(${PROJECT_NAME} PRIVATE drogon)
#
# and comment out the following lines
find_package(Drogon CONFIG REQUIRED)
target_link_libraries(${PROJECT_NAME} PRIVATE Drogon::Drogon)

# ##############################################################################

if (CMAKE_CXX_STANDARD LESS 17)
    # With C++14, use boost to support any and string_view
    message(STATUS "use c++14")
    find_package(Boost 1.61.0 REQUIRED)
    target_include_directories(${PROJECT_NAME} PRIVATE ${Boost_INCLUDE_DIRS})
elseif (CMAKE_CXX_STANDARD LESS 20)
    message(STATUS "use c++17")
else ()
    message(STATUS "use c++20")
endif ()

aux_source_directory(controllers CTL_SRC)
aux_source_directory(filters FILTER_SRC)
aux_source_directory(plugins PLUGIN_SRC)
aux_source_directory(models MODEL_SRC)

drogon_create_views(${PROJECT_NAME} ${CMAKE_CURRENT_SOURCE_DIR}/views
                    ${CMAKE_CURRENT_BINARY_DIR})
# use the following line to create views with namespaces.
# drogon_create_views(${PROJECT_NAME} ${CMAKE_CURRENT_SOURCE_DIR}/views
#                     ${CMAKE_CURRENT_BINARY_DIR} TRUE)

target_include_directories(${PROJECT_NAME}
                           PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}
                                   ${CMAKE_CURRENT_SOURCE_DIR}/models)
target_sources(${PROJECT_NAME}
               PRIVATE
               ${SRC_DIR}
               ${CTL_SRC}
               ${FILTER_SRC}
               ${PLUGIN_SRC}
               ${MODEL_SRC})
# ##############################################################################
# uncomment the following line for dynamically loading views
# set_property(TARGET ${PROJECT_NAME} PROPERTY ENABLE_EXPORTS ON)

=== orm_lib/tests/CMakeLists.txt ===
link_libraries(${PROJECT_NAME})
if(WIN32)
  link_libraries(iphlpapi)
endif(WIN32)

add_executable(db_test
    db_test.cc
    postgresql/Users.cc
    mysql/Users.cc
    sqlite3/Users.cc
)

add_executable(pipeline_test
        pipeline_test.cpp
)

add_executable(db_listener_test
        db_listener_test.cc
)

set_property(TARGET db_test PROPERTY CXX_STANDARD ${DROGON_CXX_STANDARD})
set_property(TARGET db_test PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET db_test PROPERTY CXX_EXTENSIONS OFF)

set_property(TARGET pipeline_test PROPERTY CXX_STANDARD ${DROGON_CXX_STANDARD})
set_property(TARGET pipeline_test PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET pipeline_test PROPERTY CXX_EXTENSIONS OFF)

set_property(TARGET db_listener_test PROPERTY CXX_STANDARD ${DROGON_CXX_STANDARD})
set_property(TARGET db_listener_test PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET db_listener_test PROPERTY CXX_EXTENSIONS OFF)

=== debian/changelog ===
drogon (1.8.7+ds-1.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:04:28 +0000

drogon (1.8.7+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062387

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 02:24:07 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: drogon
-Maintainer: Pierre-Elliott Bécue <pierre-elliott.becue@gandi.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Pierre-Elliott Bécue <pierre-elliott.becue@gandi.net>
 Section: web
 Priority: optional
-Build-Depends:
+Build-Depends: dpkg-dev (>= 1.22.5),
   chrpath,
   cmake,
   debhelper-compat (=13),
@@ -24,7 +25,10 @@
 Homepage: https://github.com/drogonframework/drogon
 Rules-Requires-Root: no
 
-Package: libdrogon1
+Package: libdrogon1t64
+Provides: ${t64:Provides}
+Replaces: libdrogon1
+Breaks: libdrogon1 (<< ${source:Version})
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: C++14/17-based HTTP application framework
@@ -38,7 +42,7 @@
 
 Package: libdrogon-dev
 Architecture: any
-Depends: libdrogon1 (= ${binary:Version}), libtrantor-dev, ${misc:Depends}
+Depends: libdrogon1t64 (= ${binary:Version}), libtrantor-dev, ${misc:Depends}
 Description: C++14/17-based HTTP application framework
  Drogon can be used to easily build various types of web application server
  programs using C++.
@@ -50,7 +54,7 @@
 
 Package: drogon
 Architecture: any
-Depends: libdrogon1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libdrogon1t64 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Description: C++14/17-based HTTP application framework
  Drogon can be used to easily build various types of web application server
  programs using C++.

=== debian/rules ===
#!/usr/bin/make -f
DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ --with=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr -DBUILD_SHARED_LIBS=ON -DUSE_SUBMODULE=OFF -DCMAKE_CXX_FLAGS="-std=c++20 -fcoroutines -Wno-error=restrict -g"

override_dh_auto_install:
	dh_auto_install
	chrpath -d debian/tmp/usr/bin/drogon_ctl
